package question2;

import java.util.Calendar;
import java.text.DateFormat;
import java.util.Locale;

/**
 * Gestionnaire renvoyant la valeur du capteur et 
 * la date de releve.
 * 
 * @author Jacquemin Thibault
 * @author Marleix Mathieu
 *
 */
public class TraceHandler extends Handler<Float>
{
	
	/**
	 * Constructeur de la classe TraceHandler
	 * @param successor
	 */
	public TraceHandler( Handler<Float> successor )
	{
		super( successor );
	} // TraceHandler()

	/**
	 * Prise en charge de la requete par le gestionnaire.
	 * @param value : Float transmis par un des successeurs
	 */
	public boolean handleRequest( Float value )
	{
		Calendar c= Calendar.getInstance();
		DateFormat df= DateFormat.getDateInstance( DateFormat.SHORT, Locale.FRANCE );
		DateFormat dt= DateFormat.getTimeInstance( DateFormat.SHORT, Locale.FRANCE );
		String date= df.format( c.getTime() ) + "-" + dt.format( c.getTime() );
		System.out.println( "[" + date + "] ds2438.value : " + value );

		return super.handleRequest( value );
	} // handleRequest()
} // TraceHandler
