package question1;

import java.net.*;
import java.io.*;
import java.util.*;
import java.text.DateFormat;

//import sunlabs.brazil.server.Main;

public class AppliSimulateurDS2438 implements Runnable{
    public static final int TIME_OUT = 500;
    
    private Thread    local;
    private String    urlPrefix  = "ds2438";
    private int       port       = 8999;
       
    private final static String RESPONSE = "# ibutton: DS2438; Adapter: DS9097U; Port: COM2;<br>1C0000000D536B26=";

	public static void main(String[] args){
    new AppliSimulateurDS2438();
	}

	public AppliSimulateurDS2438(){
	  local = new Thread(this);
	  local.setPriority(Thread.MAX_PRIORITY);
	  local.start();
	}
	
  
  public void run(){

    try{
      if( local == Thread.currentThread()){

        ServerSocket listen = new ServerSocket(this.port);
        listen.setSoTimeout(TIME_OUT);
        
        while(!local.isInterrupted()){
           Socket           socket = null;
           BufferedReader   in     = null;
           DataOutputStream out    = null;
           try{
             socket = listen.accept();
             in     = new BufferedReader(new InputStreamReader(socket.getInputStream()));
	           out    = new DataOutputStream( socket.getOutputStream());
	    
             String request = in.readLine(); // requte GET en premire ligne
             StringTokenizer st = new StringTokenizer(request);
             String token = st.nextToken();

             if(token.equals("GET")){
               String paramUrl = st.nextToken();
               String value = Float.toString((float)Math.random()*100.0F);
               st = new StringTokenizer(paramUrl,"/&?= ");    
               token = st.nextToken(); 
               if(token.equals(this.urlPrefix)){
                 
                   while (st.hasMoreTokens()){ 
                     token = st.nextToken(" &?=");
                     if(token.equals("value")) value = st.nextToken(" &?="); // c'est une valeur imposee, pour les tests
                   }
                 
                 Calendar c = Calendar.getInstance();
                 DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT,Locale.FRANCE);
                 DateFormat dt = DateFormat.getTimeInstance(DateFormat.SHORT,Locale.FRANCE);
                 String date = df.format(c.getTime()) + "-" + dt.format(c.getTime());
                 String from = socket.getInetAddress().getHostAddress(); // comment 
                 
                 System.out.println(from + " | " + date + " | " + RESPONSE + value + "\n");
                 send(out, RESPONSE + value);
               }else{
                 send(out,request + " <b>commande ignore</b><br>" +"prfixe attendu : <b>" + urlPrefix + "</b> ");
               }
            }else{
              send(out,request + " <b>seule la mthode GET est autorise ! </b> ");
            }
        }catch(Exception e){
            
        }finally{
           if(in!=null)in.close();
           if(out!=null)out.close();
           if(socket!=null)socket.close();
        }
      }
      if(listen!=null)listen.close();
    }
  }catch(Exception e){
      e.printStackTrace(); 
  }
  }
  

   public void send(DataOutputStream os, String message) throws Exception{
     try{
      os.write("HTTP/1.0 200 OK\r\n".getBytes());
      os.write(new String("Content-Length: " + message.length() + "\r\n").getBytes());
      os.write("Content-Type: text/html\r\n\r\n".getBytes());
      os.write(message.getBytes());
      os.flush();
     }catch(Exception e){
       e.printStackTrace();
      }
   }

  
}
