package question1;


import javax.swing.*;
import java.awt.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.text.DateFormat;

//import sunlabs.brazil.server.Main;

public class SimulateurDS2438 extends JApplet implements Runnable{
    public static final int TIME_OUT = 500;
    
    private Thread    local;
    private String    urlPrefix  = "ds2438";
    private int       port       = 8999; 
    
    private TextArea zone = new TextArea(40, 100); 
   
    private final static String RESPONSE = "# ibutton: DS2438; Adapter: DS9097U; Port: COM2;<br>1C0000000D536B26=";
    
    
	/**
	 * Called by the browser or applet viewer to inform this Applet that it
	 * has been loaded into the system. It is always called before the first 
	 * time that the start method is called.
	 */
	public void init(){
	  JRootPane rootPane = this.getRootPane();	
		rootPane.putClientProperty("defeatSystemEventQueueCheck", Boolean.TRUE);
		try{
	    String paramUrlPrefix = getParameter("PREFIX");
	    if (paramUrlPrefix != null) urlPrefix = new String(paramUrlPrefix);
	    String paramName = getParameter("PORT");
	    try{
	      if (paramName != null) port = Integer.parseInt(new String(paramName));
	     }catch(NumberFormatException nfe){ // rien pour l'instant ...
	     }
	  }catch(Exception e){
	  }
	  setLayout(new BorderLayout(5, 5));
    JPanel p = new JPanel(new FlowLayout(FlowLayout.LEFT));
    p.add(new JLabel("from | "));
    p.add(new JLabel("date | "));
    p.add(new JLabel("response sent by the virtual sensor")); 
    add("North", p);
    add("Center", zone);
      
	  local = new Thread(this);
	  local.setPriority(Thread.MAX_PRIORITY);
	  local.start();
	}

	public void stop(){
		// provide any code that needs to be run when page
		// is replaced by another page or before Applet is destroyed 
		local.interrupt();
		try{
		  Thread.sleep(SimulateurDS2438.TIME_OUT);
		}catch(Exception e){
		}
	}



  
  public void run(){

    try{
      if( local == Thread.currentThread()){

        ServerSocket listen = new ServerSocket(this.port);
        listen.setSoTimeout(TIME_OUT);
        
        while(!local.isInterrupted()){
           Socket           socket = null;
           BufferedReader   in     = null;
           DataOutputStream out    = null;
           try{
             socket = listen.accept();
             in     = new BufferedReader(new InputStreamReader(socket.getInputStream()));
	           out    = new DataOutputStream( socket.getOutputStream());
	    
             String request = in.readLine(); // requte GET en premire ligne
             StringTokenizer st = new StringTokenizer(request);
             String token = st.nextToken();

             if(token.equals("GET")){
               String paramUrl = st.nextToken();
               String value = Float.toString((float)Math.random()*100.0F);
               st = new StringTokenizer(paramUrl,"/&?= ");    
               token = st.nextToken(); 
               if(token.equals(this.urlPrefix)){
                 
                   while (st.hasMoreTokens()){ 
                     token = st.nextToken(" &?=");
                     if(token.equals("value")) value = st.nextToken(" &?="); // c'est une valeur imposee, pour les tests
                   }
                 
                 Calendar c = Calendar.getInstance();
                 DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT,Locale.FRANCE);
                 DateFormat dt = DateFormat.getTimeInstance(DateFormat.SHORT,Locale.FRANCE);
                 String date = df.format(c.getTime()) + "-" + dt.format(c.getTime());
                 String from = socket.getInetAddress().getHostAddress(); // comment 
                 
                 zone.append(from + " | " + date + " | " + RESPONSE + value + "\n");
                 send(out, RESPONSE + value);
               }else{
                 send(out,request + " <b>commande ignore</b><br>" +"prfixe attendu : <b>" + urlPrefix + "</b> ");
               }
            }else{
              send(out,request + " <b>seule la mthode GET est autorise ! </b> ");
            }
        }catch(Exception e){
            
        }finally{
           if(in!=null)in.close();
           if(out!=null)out.close();
           if(socket!=null)socket.close();
        }
      }
      if(listen!=null)listen.close();
      //zone.append("  fin de service\n");
    }
  }catch(Exception e){
      e.printStackTrace(); 
  }
  }
  

   public void send(DataOutputStream os, String message) throws Exception{
     try{
      os.write("HTTP/1.0 200 OK\r\n".getBytes());
      os.write(new String("Content-Length: " + message.length() + "\r\n").getBytes());
      os.write("Content-Type: text/html\r\n\r\n".getBytes());
      os.write(message.getBytes());
      os.flush();
     }catch(Exception e){
       e.printStackTrace();
      }
   }

  
}
